#
#  This file supports the vertical handoff protocol in advice.h.  A copy of
#  advice.h needs to be here, along with a modified h2ph.
#

package handoff;

# read advice.h but skip any of its nested includes.

sub main::do_handoff {
    my $packet = shift;
    my $if;
    my($cli, $opcode, $numbody, $if) =
        unpack('NCCA*', $packet);
    
    if ($numbody != 1 || $opcode != 0x81) {
        &main::log("*** Don't know how to handle numbody=$numbody" .
                   sprintf("opcode=0x%x", $opcode));
        return undef;
    }

    # reallyfrom tells the ip address of the client for which handoff is
    # occurring.  

    $ipaddr = join('.', ($cli >> 24) & 0xff, (($cli >> 16) & 0xff),
                   (($cli >> 8) & 0xff), ($cli & 0xff));

    # remove trailing interface number from hostname if there
    $if =~ s/\d+$//;

    # if this IP addr has a prefs entry, replace it with the prefs entry for
    # (IP addr) concat (interface name).  if no such entry exists, create it by
    # copying the default.

    &main::copy_prefs($ipaddr, "$ipaddr.$if");

    # and we should be done....
    return ($ipaddr,$if);
}

    
1;
